Resample			PROTO STDCALL :DWORD, :DWORD, :DWORD, :DWORD
DeltaToAngle		PROTO STDCALL :DWORD, :DWORD
BlendFixed			PROTO STDCALL :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD
NonUniformAverages	PROTO STDCALL :DWORD, :DWORD, :DWORD, :DWORD

.code
; ########################################################################
Resample proc uses edi esi ebx lpSrc:DWORD, lpDest:DWORD, dwWidth:DWORD, dwHeight:DWORD
	mov		esi, lpSrc
	mov		edi, lpDest
	mov		edx, dwWidth
	shr		edx, 1
	
	mov		ecx, dwWidth
	
	pxor	MM4, MM4		
	
	mov		ebx, dwHeight
	shr		ebx, 1
	ALIGN 16
	@nextline:
		
		mov		edx, ecx
		shr		edx, 2
		ALIGN 16
		@nextpixel:
			movq		MM0, [esi]			; MM0: X2 R2 G2 B2-X1 R1 G1 B1
			movq		MM1, [esi+8]		; MM1: X4 R4 G4 B4-X3 R3 G3 B3
			movq		MM2, [esi+4*ecx]		; MM2: X6 R6 G6 B6-X5 R5 G5 B5
			movq		MM3, [esi+4*ecx+8]	; MM3: X8 R8 G8 B8-X7 R7 G7 B7
			
			movq		MM5, MM0
			movq		MM6, MM2
			
			punpckhbw 	MM0, MM4			; MM0: 00 X2 00 R2-00 G2 00 B2
			punpckhbw 	MM2, MM4			; MM2: 00 X6 00 R6-00 B6 00 B6
			punpcklbw 	MM5, MM4			; MM5: 00 X1 00 R1-00 G1 00 B1
			punpcklbw 	MM6, MM4			; MM6: 00 X5 00 R5-00 G5 00 B5
			
			paddw		MM0, MM2
			paddw		MM0, MM5
			paddw		MM0, MM6
			psrlw		MM0, 2				
			
			; second pixel:
			
			movq		MM5, MM1
			movq		MM6, MM3
			
			punpckhbw 	MM1, MM4			; MM1: 00 X4 00 R4-00 G4 00 B4
			punpckhbw 	MM3, MM4			; MM3: 00 X8 00 R8-00 B8 00 B8
			punpcklbw 	MM5, MM4			; MM5: 00 X3 00 R3-00 G3 00 B3
			punpcklbw 	MM6, MM4			; MM6: 00 X7 00 R7-00 G7 00 B7
			
			paddw		MM1, MM3
			paddw		MM1, MM5
			paddw		MM1, MM6
			psrlw		MM1, 2			
				
			; now: 	MM0: 00 XQ 00 RQ-00 GQ 00 BQ ;where Q is the first mixed pixel
			; now: 	MM1: 00 XP 00 RP-00 GP 00 BP ;where P is the second mixed pixel
			; output should be: BQ GQ RQ XQ-BP GP RP XP (in mem)
			;					XP RP GP BP XQ RQ GQ BQ (in reg)
			
			packuswb	MM0, MM1
			movq		[edi], MM0
			
			
			add		esi, 16
			add		edi, 8
			dec		edx
			jnz		@nextpixel	
		
		lea		esi, [esi+4*ecx]
		dec		ebx
		jnz		@nextline
	emms
ret
Resample endp

DeltaToAngle	proc deltaX:DWORD, deltaY:DWORD
LOCAL	temp:DWORD

	.data
	dta_rangeval_000	REAL4 1800.0
	.code
	mov		ecx, deltaX
	mov		edx, deltaY
	
	
	;	//Rad's to 0-3600 degrees
	;	#define RADTODEG 572.9578f

	
	or		edx, edx
	jnz		@dta1
	mov		eax, 900
	cmp		ecx, 0
	jg		@F
	mov		eax, 2700
	@@:
	ret
	@dta1:
	xor		eax, eax
	or		ecx, ecx
	jnz		@dta2
	cmp		edx, eax
	jg		@F
	mov		eax, 1800
	@@: 
	ret
	ret
	@dta2:
	
	
  
	finit
	
	fild	deltaY
	fild	deltaX	

			;ST(0)=dx, ST(1)=dy
	fpatan						;ST(0)=angle in radians
	fldpi						;ST(1)=angle in radians, ST(0)=pi
	fdivp	ST(1),ST(0)			;ST(0)=angle/pi
;o	fld		dta_rangeval_000	;ST(0)=1800, ST(1)=angle/pi
;o	fmul	ST(1), ST(0)		;ST(1)=(angle/pi) * 1800 = angle in degrees (*10)
	
	;n:
	fmul	dta_rangeval_000	;ST(0)=(angle/pi) * 1800 = angle in degrees (*10)
	
;0	fstp	temp
	fistp	temp				;ST(0)=angle in degrees (*10)
	mov		eax, 900
	sub		eax, temp
	
	@@:
	cmp		eax, 0
	jge		@F
	add		eax, 3600
	jmp		@B
	@@:
	
	@@:
	cmp		eax, 3600
	jle		@F
	sub		eax, 3600
	jmp		@B
	@@:
ret
DeltaToAngle	endp	



BlendFixed proc uses edi esi ebx lpData:DWORD,\
			 dwX:DWORD,dwY:DWORD,\
			 dwWidth:DWORD, dwHeight:DWORD,\
			 dwColor:DWORD, dwBmpWidth:DWORD
	
	mov			eax, dwColor
	movd		MM7, eax
	pxor		MM6, MM6
	punpcklbw 	MM7, MM6			; MM1: 0 C 0 C-0 C 0 C
	
	mov		esi, lpData
	mov		eax, dwBmpWidth
	shl		eax, 2
	mov		ecx, eax
	mul		dwY
	add		esi, eax
	mov		eax, dwX
	shl		eax, 2
	add		esi, eax
	
	mov		edi, dwHeight
	
	xor		ebx, ebx
	ALIGN 16
	@nextline:
		
		mov		edx, dwWidth
		shr		edx, 2
		xor		eax, eax
		ALIGN 16
		@nextpixel:
			movq		MM0, [esi+eax*8]	; MM0: X R G B-X R G B
			movq		MM2, [esi+eax*8+8]	; MM2: X R G B-X R G B
			movq		MM1, MM0
			movq		MM3, MM2
			punpcklbw 	MM0, MM6			; MM0: 0 X 0 R-0 X 0 B
			punpckhbw 	MM1, MM6			; MM1: 0 X 0 R-0 X 0 B
			punpcklbw 	MM2, MM6			; MM2: 0 X 0 R-0 X 0 B
			punpckhbw 	MM3, MM6			; MM3: 0 X 0 R-0 X 0 B
						
			paddw		MM0, MM7
			paddw		MM1, MM7
			paddw		MM2, MM7
			paddw		MM3, MM7
			
			psrlw		MM0, 1
			psrlw		MM1, 1
			psrlw		MM2, 1
			psrlw		MM3, 1
			
			packuswb	MM0, MM1
			packuswb	MM2, MM3
			movq		[esi+eax*8], MM0
			movq		[esi+eax*8+8], MM2
			add			eax, 2
			dec			edx
			jnz			@nextpixel	
		
		add		esi, ecx
		inc		ebx
		cmp		ebx, edi
		jb		@nextline
	emms
ret
BlendFixed endp

.data
rd1_232	real10 0.000000000232830643653869628906250
.code

; NonUniformAverages (C) by BitRake.
;
; arrDest    Pointer to buffer of size lenDest*4.  This buffer will hold an
;            array of REAL4 values returned from proceedure.
; arrSrc     Pointer to buffer of size lenSrc*4.  This buffer holds lenSrc REAL4
;            values to be averaged by the proceedure.
;
; Thanks to bitRAKE for creating this proc !
;
NonUniformAverages PROC uses esi edi, arrDest:DWORD, arrSrc:DWORD, lenDest:DWORD, lenSrc:DWORD
	LOCAL fTemp:QWORD

	mov esi,arrSrc
	mov edi,arrDest

	mov edx,lenDest
	cmp edx,lenSrc
	jge Error

	xor eax,eax
	div lenSrc

	and DWORD PTR [fTemp+4],0
	; 1/2^32
	fld rd1_232

	fild lenDest
	fidiv lenSrc

	fldz ; init

Main:
	add edx,eax
	jc @F

	fadd REAL4 PTR [esi]
	add esi,4
	jmp Main
@@:
	fadd REAL4 PTR [esi]

	mov DWORD PTR [fTemp],edx
	fild fTemp
	fmul st(0),st(3)
	fmul REAL4 PTR [esi]
	fdiv st(0),st(2)
	fxch st(1)

	fsub st(0),st(1)
	fmul st(0),st(2)
	fstp REAL4 PTR [edi]

	add esi,4
	add edi,4
	dec lenDest
	jne Main

	fstp st(0)
	fstp st(0)
	fstp st(0)
	ret
	
Error:
	jne @F
	; this isn't exactly an error 
	mov ecx,edx
	rep movsd
	or eax,-1
	ret

@@:	xor eax,eax ; error checking isn't a bad thing
	ret
NonUniformAverages ENDP


